package ru.ulstu.extractor;

import org.eclipse.jgit.api.errors.GitAPIException;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.List;

import static ru.ulstu.extractor.RepoController.URL;

@RestController
@RequestMapping(URL)
public class RepoController {
    public static final String URL = "/";
    private final GitRepositoryService gitRepositoryService;

    public RepoController(GitRepositoryService gitRepositoryService) {
        this.gitRepositoryService = gitRepositoryService;
    }

    @GetMapping("clone")
    public void cloneRepository(@RequestParam("url") String url) throws GitAPIException, IOException {
        gitRepositoryService.cloneOrUpdateRepo(url);
    }

    @GetMapping("commits")
    public List<Commit> getCommits(@RequestParam("url") String url) throws GitAPIException, IOException {
        return gitRepositoryService.getCommits(url);
    }

}
